// Connection.cc
// Dan Pemstein
// Little Celtic Warlock Software 2001
// ANN++ Library 0.1

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.

#ifndef CONNECTION_CC
#define CONNECTION_CC

#include "Connection.h"

Connection::Connection()
	:	value_ (0),
		next_ (0),
		charge_ (0),
		inLayer_ (0),
		inNode_ (0),
		outLayer_ (0),
		outNode_ (0)
{
}

Connection::Connection(Neuron *value, Connection *next)
	:	value_ (value),
		next_ (next),
		charge_ (0),
		inLayer_ (0),
		inNode_ (0),
		outLayer_ (0),
		outNode_ (0)
{
}

Connection::~Connection()
{
}

Connection
*Connection::next () const
{
	return next_;
}

void
Connection::next(Connection *new_next)
{
	next_ = new_next;
}

Neuron
*Connection::value () 
{
	return value_;
}

void
Connection::value (Neuron *value)
{
	value_ = value;
}

void
Connection::position (size_t a, size_t b,
                      size_t c, size_t d)
{
	inLayer_ = a;
	inNode_ = b;
	outLayer_ = c;
	outNode_ = d;
}

void
Connection::position (size_t *pos)
{
	pos[0] = inLayer_;
	pos[1] = inNode_;
	pos[2] = outLayer_;
	pos[3] = outNode_;
}

void
Connection::placeCharge(const double &charge)
{
	if (value_ != 0)
		(*value_).placeCharge(charge);
	charge_ = charge;
}

double
Connection::getCharge()
{
	return charge_;
}

#endif /* CONNECTION_CC */
