// SigmoidUnit.h
// Dan Pemstein
// Little Celtic Warlock Software 2001
// ANN++ Library 0.1

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.

#ifndef SIGMOID_UNIT_H
#define SIGMOID_UNIT_H

#include <stdlib.h>
#include <math.h>
#include "Unit.h"

class SigmoidUnit: public Unit 
{
// A sigmoid unit implementation of a unit class.  A standard
// unit type and the most common in backprop nets
public:
	// Constructor. 
	SigmoidUnit();
	
	// Destructor
	virtual ~SigmoidUnit();

	void reset();

	void addCharge(const double &);

	double getOutput();

private:
	double net_;
};

#endif /* SIGMOID_UNIT_H */
